#!/bin/sh
VERSION=30
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions
ERHOME=$PLUGINDIR/ER
CHANNEL=1
ERDELTA=/usr/lib/enigma2/python/Plugins/Extensions/ER/.erdelta

TIMERS=$ERHOME/timers.xml
TIMERSORIG=/etc/enigma2/timers.xml
PROGRAMC=$ERHOME/0_RECORDTIMER/1_RECORD_CHANNEL_
PROGRAMBH=$ERHOME/0_RECORDTIMER/1_RECORD_BEGIN_HOUR_
PROGRAMBM=$ERHOME/0_RECORDTIMER/1_RECORD_BEGIN_MINUTE_
PROGRAMEH=$ERHOME/0_RECORDTIMER/1_RECORD_END_HOUR_
PROGRAMEM=$ERHOME/0_RECORDTIMER/1_RECORD_END_MINUTE_
TIMERSTMP=$ERHOME/timers.tmp
RECORD=$ERHOME/record.sh

rm $TIMERSTMP > /dev/null 2<&1

SERVICEREF=$ERHOME/serviceref.lst
USERBOUQUET=/etc/enigma2/userbouquet.favourites.tv
cp $USERBOUQUET $SERVICEREF
chmod 777 $SERVICEREF
dos2unix $SERVICEREF
sed -ie s!"#SERVICE "!!g $SERVICEREF
sed -ie s!"#NAME Favourites (TV)"!!g $SERVICEREF
sed '/^[ 	]*$/d' < $SERVICEREF > $TIMERSTMP && mv $TIMERSTMP $SERVICEREF
# now we have plain serviceref list !
chmod 777 $SERVICEREF

#
LATER=2
echo `wc -l $SERVICEREF` > $TIMERSTMP
sed -ie s!$SERVICEREF!!g   $TIMERSTMP
NUMCHANNELS=`cat $TIMERSTMP`
##echo "Number of Channels in Favourites $NUMCHANNELS"

ERDELTA=`cat $ERDELTA`

# processing time
CDATE=`date -u`
CSEC=`date -u +'%s'`
CHOUR=`date -u +'%H'`
CMINUTE=`date -u +'%M'`
CMONTH=`date -u +'%m'`
CMONTHDAY=`date -u +'%d'`
CWEEKDAY=`date -u +'%w'`
#echo "Current time in seconds since 1970: $CSEC"
LSEC=`expr $LATER "*" 3600`
#echo "Seconds in the Future $LSEC"
LSEC=`expr $LSEC "+" $CSEC`

#
# correct UTC with ER delta
#
CHOUR=`expr $CHOUR "+" $ERDELTA`

# check for Channel 
if  [  ! -f $PROGRAMC*  ]; then
    CHANNEL="1"
else
   CHANNEL=`cat $PROGRAMC*`
fi
#    echo "Channel for recording is $CHANNEL"
# check for begin hour 
if  [  ! -f $PROGRAMBH*  ]; then
    BEGINH=$CHOUR
else
   BEGINH=`cat $PROGRAMBH*`
fi
#    echo "Begin hour for recording is $BEGINH"
# check for begin minute 
if  [  ! -f $PROGRAMBM*  ]; then
    BEGINM=$CMINUTE
else
   BEGINM=`cat $PROGRAMBM*`
fi
#    echo "Begin minute for recording is $BEGINM"
# check for end hour 
if  [  ! -f $PROGRAMEH*  ]; then
    ENDH=`expr $BEGINH "+" 2`
else
   ENDH=`cat $PROGRAMEH*`
fi
#    echo "End hour for recording is $ENDH"
# check for end minute 
if  [  ! -f $PROGRAMEM*  ]; then
    ENDM=$BEGINM
else
   ENDM=`cat $PROGRAMEM*`
fi
#    echo "End minute for recording is $ENDM"
#echo "Currently Recording Channel $CHANNEL from $BEGINH:$BEGINM to $ENDH:$ENDM"



case "$1" in
"channelup")
    CHANNEL=`expr $CHANNEL "+" 1`
    if [ $CHANNEL -gt $NUMCHANNELS ]; then
       CHANNEL="1"
    fi
;;
"channeldown")
    CHANNEL=`expr $CHANNEL "-" 1`
    if [ $CHANNEL  -lt "1" ]; then
       CHANNEL=$NUMCHANNELS
    fi
;;
"beginhourup")
    BEGINH=`expr $BEGINH "+" 1`
    ENDH=`expr $ENDH "+" 1`
    if [ $BEGINH = "24" ]; then
       BEGINH="0"
    fi
    if [ $ENDH = "24" ]; then
       ENDH="0"
    fi
;;
"beginhourdown")
    BEGINH=`expr $BEGINH "-" 1`
    ENDH=`expr $ENDH "-" 1`
    if [ $BEGINH = "-1" ]; then
       BEGINH="23"
    fi
    if [ $ENDH = "-1" ]; then
       ENDH="23"
    fi
;;
"endhourup")
    ENDH=`expr $ENDH "+" 1`
    if [ $ENDH = "24" ]; then
       ENDH="0"
    fi
;;
"endhourdown")
    ENDH=`expr $ENDH "-" 1`
    if [ $ENDH = "-1" ]; then
       ENDH="23"
    fi
    rm $PROGRAMEH* >> /dev/null 2>&1
    echo $ENDH > $PROGRAMEH$ENDH
;;
"beginminuteup")
    BEGINM=`expr $BEGINM "+" 1`
    ENDM=`expr $ENDM "+" 1`
    if [ $BEGINM -gt "59" ]; then
       BEGINM="0"
    fi
    if [ $ENDM -gt "59" ]; then
       ENDM="0"
    fi
;;
"beginminutedown")
    BEGINM=`expr $BEGINM "-" 1`
    ENDM=`expr $ENDM "-" 1`
    if [ $BEGINM -lt "0" ]; then
       BEGINM="59"
    fi
    if [ $ENDM -lt "0" ]; then
       ENDM="59"
    fi
;;
"endminuteup")
    ENDM=`expr $ENDM "+" 1`
    if [ $ENDM -gt "59" ]; then
       ENDM="0"
    fi
;;
"endminutedown")
    ENDM=`expr $ENDM "-" 1`
    if [ $ENDM -lt "0" ]; then
       ENDM="59"
    fi
;;
"deletexml")
echo "Deleting timers.xml works only if root"
init 2
rm /etc/enigma2/timers.xml > /dev/null 2>&1
init 3
exit 0
;;
"delete")
echo "Deleting timer"
rm $ERHOME/0_RECORDTIMER/1_* > /dev/null 2>&1
exit 0
;;
*)
echo "No Programtimerchange"
;;
esac

    if [ $BEGINH = "24" ]; then
       BEGINH="0"
    fi
    if [ $BEGINH = "-1" ]; then
       BEGINH="23"
    fi
    if [ $ENDH = "24" ]; then
       ENDH="0"
    fi
    if [ $ENDH = "-1" ]; then
       ENDH="23"
    fi
echo "Recording Channel $CHANNEL from $BEGINH:$BEGINM to $ENDH:$ENDM"
    rm $PROGRAMC* >> /dev/null 2>&1
    echo $CHANNEL > $PROGRAMC$CHANNEL
    rm $PROGRAMBH* >> /dev/null 2>&1
    echo $BEGINH > $PROGRAMBH$BEGINH
    rm $PROGRAMEH* >> /dev/null 2>&1
    echo $ENDH > $PROGRAMEH$ENDH
    rm $PROGRAMBM* >> /dev/null 2>&1
    echo $BEGINM > $PROGRAMBM$BEGINM
    rm $PROGRAMEM* >> /dev/null 2>&1
    echo $ENDM > $PROGRAMEM$ENDM

    rm $TIMERSTMP > /dev/null 2<&1

exit 0
